# Direttive suggerite
use strict ;
use warnings ;

# La direzione INPUT-OUTPUT è stabilita dai simboli di shell (<, > e >>).
# In caso di errore stampiamo lo stato dell'ultima chiamata (variabile $!)
# (vedi lezione 2: variabili riservate)
open(my $input	, "<"	, "input.txt"		)	or die "File non trovato: $!" ;
open(my $output	, ">"	, "output.txt"		) 	or die "File non trovato: $!" ;
open(my $append	, ">>"	, "append.txt"		)	or die "File non trovato: $!" ;

# La lettura dei file si adatta contestualmente alla variabile (scalare o array)
# Esempio di lettura tramite variabile scalare
my $first_line = <$input> ;
print "\nPrima linea del file : ".$first_line."\n" ;
# Esempio di lettura tramite variabile vettore
my @all_lines = <$input> ;
print "Altre linee del file :\n\n" ;
print @all_lines ;
print "\n\n" ;

# Lettura dell'intero file (detto anche "slurping")
# Nota: riapriamo il file per resettare il cursore di lettura
print "\nLettura integrale del file:\n\n" ;
open(my $file, "<", "input.txt") or die "File non trovato: $!" ;
my $riga = 0 ;
while (<$file>) { 
	$riga++ ;
	print "$riga -> $_" ;
}
print "\n" ;

# Al termine delle operazioni chiudiamo tutti i files
close $input 	or die "$input: $!" ;
close $output 	or die "$output: $!" ;
close $append	or die "$append: $!" ;
close $file		or die "$file: $!" ;