# Direttive suggerite
use strict ;
use warnings ;
# Scommentare la riga seguente se vogliamo evitare il controllo 
# "defined" all'interno della subroutine "checkVar()"
#no warnings 'uninitialized';

# Esempi di utilizzo delle diverse subroutine
println() ;
println("Esempio di utilizzo della subroutine (println)") ;
printLines("Altro esempio di subroutine (printLines)") ;
printLines("Stampa multipla (printLines)", 5) ;
printLines("Invocazione sbagliata (printLines)", 5, 123) ;
println() ;

# Questo NON funziona, perché println non è una keyword riservata
# println "Esempio di utilizzo della subroutine (senza parentesi)" ;

# Subroutine di stampa di una riga (aggiunge carattere NEW LINE)
sub println {
	my $arg = shift ;
	print $arg if (checkVar($arg)) ;
	print "\n" ;
}

# Subroutine di stampa di più righe (stampa n righe uguali)
sub printLines {
	my ($arg, $num, @others) = @_ ;
	if (checkVar(@others)) {
		println("Too many arguments: @others") ;
		return ;
	}
	elsif (checkVar($num))	{	
		println($arg) for 1..$num ;
	} else {
		println($arg) ;
	}
}

# Subroutine di controllo (verifica che la variabile sia definita)
sub checkVar {
	my $arg = shift ;
	return 1 	if (defined $arg && length $arg > 0) ;
	return 0 ;
}